# Apollo iOS

@Metadata {
   @TechnologyRoot   
}

API Reference Documentation for Apollo iOS.

## Overview

Our API reference is automatically generated directly from the inline comments in our code. If you're contributing to Apollo, all you have to do is add inline documentation comments, conforming to [DocC formatting guidelines](https://developer.apple.com/documentation/xcode/writing-symbol-documentation-in-your-source-files), and they will appear here.

See something missing in the documentation? Add inline documentation comments to the code, and open a pull request!

To run the documentation generator, cd into the SwiftScripts folder and run

```bash
swift run DocumentationGenerator
```

## Libraries

**[Apollo](/documentation/apollo)**

The core Apollo client library.

**[ApolloAPI](/documentation/apolloapi)**

The internal models shared by the [``Apollo``](/documentation/apollo) client and the models generated by [``ApolloCodegenLib``](/documentation/apollocodegenlib)

**[ApolloCodegenLib](/documentation/apollocodegenlib)**

The code generation engine used to generate model objects for an application from a GraphQL schema and operation set.

**[ApolloSQLite](/documentation/apollosqlite)**

A [`NormalizedCache`](/documentation/apollo/normalizedcache) implementation backed by a `SQLite` database.

**[ApolloWebSocket](/documentation/apollowebsocket)**

A web socket network transport implementation that provides support for [`GraphQLSubscription`](/documentation/apolloapi/graphqlsubscription) operations over a web socket connection.

**[ApolloPagination](/documentation/apollopagination)**

A library that provides support for fetching and watching paginated queries with [``Apollo``](/documentation/apollo).  
