# ``ApolloAPI``

The internal models shared by the [`Apollo`](/documentation/apollo) client and the models generated by [`ApolloCodegenLib`](/documentation/apollocodegenlib)

## Overview

This library allows you to use your generated models without importing the full [``Apollo``](/documentation/apollo) client. The generated models import ``ApolloAPI`` and expose the necessary functionality. For most use cases, *you should not need to import ``ApolloAPI`` into your code.*

## Topics

### Schema Types

- ``Object``
- ``Interface``
- ``Union``
- ``InputObject``
- ``EnumType``

### Scalar Types

- ``AnyScalarType``
- ``ScalarType``
- ``CustomScalarType``

### JSON Conversion

- ``JSONValue``
- ``JSONObject``
- ``JSONEncodable``
- ``JSONEncodableDictionary``
- ``JSONDecodable``
- ``JSONDecodingError``
